/* Ce programme a pour but de remplir l'EEPROM avec 10 Algorithmes qui étaient sur la Machine Elementaire
   avec une configuration de BARILLET et surtout les textes à afficher sur l'écran OLED.
   Quand ce programme aura été téléversé et activé, téléverser les logiciels de démonstration.  */

#include <EEPROM.h>

//------------------- Déclaration des constante du programme ----------------

#define Version_logiciel "Contenu EEPROM du 18 Decembre 2022." //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

//----------------------- Déclaration des variables -------------------------

byte Compteur, OCTET;
int PTR;
char Caractere;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

//==================================================================================================
byte CLONE[1024] = {2,1,1,1,1,1,1,2,1,1,2,2,2,2,1,1,
                    1,1,2,1,1,2,1,1,1,1,2,1,1,2,1,1,
                    1,1,2,1,1,2,1,1,1,1,2,2,2,2,1,1,
                    2,1,1,1,1,1,1,2,
                    //--------- Ci-avant : Configuration BARILLET ---------
                    1,18,2,18,2,18,2,20,3,20,3,20,3,18,4,18,
                    4,18,4,20,5,20,5,20,5,18,6,18,6,18,6,20,7,
                    20,7,20,7,18,8,18,8,18,8,20,9,20,9,20,9,
                    18,10,18,10,18,10,20,1,20,1,20,1,0,0,0,0,0,0,
                    //--------------- Ci-avant programme 001 --------------
                    55,0,2,0,0,8,0,8,0,0,0,8,3,18,
                    0,16,0,16,4,10,5,16,0,0,0,0,0,8,0,8,
                    6,18,7,8,0,16,9,0,0,16,0,16,8,10,5,16,
                    0,10,5,0,0,20,0,0,21,0,0,0,0,0,0,0,
                    0,0,0,0,0,28,17,6,17,2,16,0,17,3,17,3,
                    17,3,17,4,17,4,17,4,18,5,18,5,18,5,20,4,
                    20,4,20,4,17,7,17,7,17,7,17,8,17,8,17,8,
                    18,9,18,9,18,9,18,10,18,10,18,10,20,11,20,11,
                    20,11,20,8,20,8,20,8,34,9,7,17,2,16,2,16,
                    3,0,0,16,0,9,4,9,4,8,4,8,5,0,0,0,
                    0,8,6,0,0,12,0,1,11,1,11,0,11,8,8,0,
                    0,8,0,17,9,17,9,16,9,16,10,0,0,0,0,16,
                    6,0,0,20,0,0,0,0,0,0,21,54,0,2,0,0,
                    8,0,10,3,0,21,0,0,8,0,16,4,16,4,18,5,
                    0,21,0,0,16,0,8,2,0,0,0,0,0,0,0,0,
                    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                    0,0,0,0,0,0,0,0,0,0,0,0,0,0,29,0,
                    2,0,2,8,0,9,7,9,3,0,11,8,0,8,0,8,
                    4,8,0,8,0,18,5,16,0,16,0,16,6,16,0,16,
                    0,10,2,8,0,8,0,8,8,8,0,8,0,20,9,16,
                    0,16,0,16,10,16,0,16,0,12,2,0,0,0,0,0,
                    21,52,18,2,16,0,8,6,16,0,0,0,16,3,16,0,
                    0,0,12,4,8,0,0,0,8,5,8,0,16,1,16,1,
                    8,0,20,7,16,10,16,0,0,0,16,8,16,0,0,0,
                    12,9,8,0,0,0,8,6,16,0,0,0,16,1,0,0,
                    0,0,0,0,18,16,2,17,0,0,0,8,4,8,4,0,
                    7,16,4,16,0,8,6,18,5,20,3,12,6,16,0,16,
                    4,18,4,8,0,8,0,16,1,0,0,0,0,0,21,0,
                    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                    0,0,0,0,0,0,0,12,0,2,0,0,8,0,8,0,
                    0,0,16,3,17,4,0,0,0,8,16,0,0,0,16,5,
                    18,0,12,6,12,6,8,0,8,0,8,7,8,0,0,0,
                    16,3,16,9,16,9,16,0,16,0,16,0,16,10,0,0,
                    0,0,0,21,0,0,0,0,0,0,53,18,2,16,0,16,
                    0,8,3,0,0,8,5,10,4,8,0,8,0,16,1,0,
                    0,16,8,0,0,12,0,8,6,9,7,9,0,8,0,16,
                    1,0,0,0,11,0,0,20,0,16,9,0,0,0,10,16,
                    0,0,1,17,0,0,0,0,21,0,0,16,0,2,0,255,};

void setup() {
  Serial.begin(115200); Serial.println(); Serial.println(); Serial.println(Version_logiciel);
  Serial.println();
  Effacer_La_zone_EEPROM_PGM_Etendu();
  TEXTE_a_inscrire_en_EEPROM.reserve(30); } // 30 caractères sont très suffisants.

void loop() {
  PTR = 0; Serial.print(F("Ecriture en EEPROM les TEXTES.")); Serial.println(); Serial.println();
  TEXTE_a_inscrire_en_EEPROM = "PLATEAU      Motif"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "SAUVE   RECHARGE"; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "Arrange   Run >PLT"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Origine   Pos.T"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 202); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "TE"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "RAZ"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OUINONTmp Sature"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "CHARGER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "SAUVEGARDER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "EFFACER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Fuite"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OPTIONSR"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 201); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "DIGER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PG"; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "MODIFIER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "FORMATER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "RUN"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "BARILLET"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "EEPROM"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PROGRAMME"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " ---Pgm"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Transf"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "rer"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Transition : "; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 'R'); PTR++; EEPROM.write(PTR, 233); PTR++;
  EEPROM.write(PTR, 'f'); PTR++; EEPROM.write(PTR, 233); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "rence le "; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 201); PTR++;
  TEXTE_a_inscrire_en_EEPROM = "TENDU "; Ecrire_Texte_en_EEPROM();
  EEPROM.write(227, 33); EEPROM.write(228, 3); // Position tête de L/E en 33 et Origine en 3.
  PTR = 295;
  Serial.println(); Serial.print(F("Ecriture en EEPROM des algorithmes.")); Serial.println();
  while (PTR < 1024) {EEPROM.write(PTR, CLONE[PTR - 295]); PTR++;}
  Serial.println(); Liste_le_contenu_EEPROM(); INFINI: goto INFINI;}

//====================================== Routines de servitude =====================================

void Effacer_La_zone_EEPROM_PGM_Etendu() {
   Serial.println(); Serial.print(F("EFFACE la zone PGM ETENDU.")); Serial.println();
  PTR = 229; while (PTR < 295) {EEPROM.write(PTR, 255); PTR++;}}
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // N'envoyer que le TEXTE.
  Serial.print(F("PTR = ")); Serial.print(PTR); Serial.print(F(" "));
  while (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0') {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++;}
  Serial.println(); }
  
byte Lire_Octet_EEPROM(int ADRESSE) {return eeprom_read_byte((unsigned char*) ADRESSE);}

void Liste_le_contenu_EEPROM() {
  Serial.println(F("  Liste le contenu de l'EEPROM.")); PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC(); Lister_un_BLOC();Lister_un_BLOC();}
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}

void Ecrire_Octet_EEPROM(int ADRESSE, byte Octet) {eeprom_write_byte((unsigned char*) ADRESSE, Octet);}
   
void Lister_OCTET() {
  byte octet = Lire_Octet_EEPROM(PTR);
  if (octet < 16) Serial.print('0'); 
  Serial.print(octet,HEX);
  Serial.print(' '); PTR++; }

