
/*    >>>>>> Quand le matériel sera définitif, optimiser les valeur de comparaison   <<<<<<
      >>>>>> dans la procédure Tester_le_Clavier() en utilisant P09 qui les affiche. <<<<<<

 Programme gérant les fonctions suivantes :
   • Simule l'affichage du BARILLET en mode graphique. La valeur du nombre de cycles HORLOGE
     est incrémentée à ca cadence la plus rapide de l'affichage dans ce mode.
   • Simule la GRILLE du BARILLET. Les coordonnées de l'origine sont incrémentées 5 fois par seconde.
   • Chaque fois que l'on clique sur le BP3 du clavier on chage du type d'affichage.
   • Chaque fois que l'on clique sur le BP2 on inverse "Écran noir".
   • Le BP1 fige ou rétablit l'incrémentation du compteur ou de l'origine.
   • Le mode grahique simule un plateau entièrement à "B", à "0" ou à "1". BP4 et BP5 servent à
     modifier par recyclage les trois valeurs pour observer le visuel qui en résulte.
   
Branchements à effectuer :  Identique à ceux décrits dans le croquis du démonstrateur P09.
--------------------------
                                         PGM               RAM dynamique
Compilateur version 1.7.9          12008 Octets (39%)     286 Octets (13%)    */

//--------------------- Déclarations pour le matériel -----------------------
#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE); // Usage de la ligne I2C (Two Wire Interface)
#include <EEPROM.h>
//------------- Définition des broches d'entrées analogiques ----------------
#define Ligne_trois_touches 14 // A0 pour lire le clavier à 3 BP. 
#define Ligne_deux_touches 15  // A1 pour lire le clavier à 2 BP. 
#define BP_central 16          // A2 pour lire le bouton central du codeur rotatif.

//-------------- Définition des broches de sorties Binaires -----------------
#define Codeur_A 3    // D2 : DT
#define Codeur_B 2    // D3 : CLK 
#define BUZZER 4      // D4 : BUZZER de type actif ou passif.
#define ROUGE 5       // Anode LED ROUGE.
#define VERT 6        // Anode LED Verte.
#define BLEU 7        // Anode LED bleue.

//------------------- Déclaration des constante du programme ----------------
#define NB_tests_antirebonds 30 // Nombre de tests de stabilisation B.P.

//----------------------- Déclaration des variables -------------------------

boolean Grille, Ecran_noir, Incrementation;

byte Num_BP, Num_PGM, Origine, Etat_des_BITs, Pointeur, Position_Index;

int PTR, U_sur_D0, U_sur_D1;

unsigned long Nb_Cycles_Horloge, T_microP;
 
//---------------------------------------------------------------------------

void setup() {
  u8g.setFont(u8g_font_profont12); // Police de matrices de 6x10 pixels lettres MAJ/min comprises.
  //---------------------- Définition des vecteurs d'interruption ----------------------
  pinMode(BUZZER, OUTPUT); digitalWrite(BUZZER, LOW);
  pinMode(ROUGE, 
  OUTPUT); pinMode(VERT, OUTPUT); pinMode(BLEU, OUTPUT); Eteindre_la_LED();
  //------------------------------- Initialisation des variables   //-------------------------------
  Ecran_noir = false; Etat_des_BITs = 0; Grille = false; Incrementation = true;
  Num_PGM = 73; Nb_Cycles_Horloge = 0; Origine = 1;}

void loop() {
  if (Grille) Affiche_la_GRILLE(); else Affiche_le_BARILLET();
  if (Incrementation) {
      Nb_Cycles_Horloge = Nb_Cycles_Horloge + 10000;
      Origine++; if (Origine == 57) Origine = 1; if (Grille) Delay_200();}
  Tester_le_Clavier();
  switch(Num_BP) {
    case 1 : {Incrementation = !Incrementation; break;}
    case 2 : {Ecran_noir = !Ecran_noir;
             if (Ecran_noir) u8g.sleepOn(); else u8g.sleepOff();; break;}  
    case 3 : {Grille = !Grille; break;}
    case 4 : {Etat_des_BITs++; if (Etat_des_BITs == 3) Etat_des_BITs = 0; break;}
    case 5 : {Etat_des_BITs--; if (Etat_des_BITs == 255) Etat_des_BITs = 2;}}}

  //---------------------- Routines de servitude pour l'utilisation de l'EEPROM ----------------------

void BIP() {
   for (int I=0; I < 700; I++) {
        digitalWrite(BUZZER, HIGH); delayMicroseconds(70); digitalWrite(BUZZER, LOW); delayMicroseconds(130);}}

void Aff_TEXTE_EEPROM(int PTR, byte Longueur) {// Routines pour les affichages textes EEPROM.
    for (byte I=0; I<Longueur; I++) {u8g.print(char(EEPROM.read(PTR))); PTR++;}; }

void AFF_0() {u8g.print('0');}

void SPC() {u8g.print(' ');}

void SPC_Interrogation() {Aff_TEXTE_EEPROM(194,2);}

void Afficher_un_texte(byte X, byte Y, int PTR, byte Longueur) {
  u8g.setPrintPos(X, Y); Aff_TEXTE_EEPROM(PTR,Longueur);}

void Eteindre_la_LED() {digitalWrite(ROUGE, LOW); digitalWrite(VERT, LOW); digitalWrite(BLEU, LOW);}

  //-------------------- Routines de servitude pour traiter le capteur incrémental -------------------

void Delay_antirebonds() {for(int T=0; T<1000; T++);} // Valeur de 100 expérimentale.
 
  //----------------------- Routines de servitude pour traiter le petit clavier ----------------------

void ATTENDRE_le_relacher() {
  byte COMPTEUR = 0; digitalWrite(VERT, HIGH); Delay_60();// Attendre_la_stabilisation du travail.
  digitalWrite(VERT, HIGH);
  while (COMPTEUR < NB_tests_antirebonds) {// Attendre_la_stabilisation du repos :
        if ((analogRead(Ligne_trois_touches) < 813) || (analogRead(Ligne_deux_touches) < 776)) COMPTEUR = 0;
        else COMPTEUR++;}
  digitalWrite(VERT, LOW);}

void Tester_le_Clavier() {// Les valeurs tiennent compte de VCC = 4V car fourni par la carte NANO.
  U_sur_D0 = 0; U_sur_D1 = 0; Num_BP = 0; // Signale aucun B.P. utilisé.
  for (byte I = 0; I < NB_tests_antirebonds; I++) U_sur_D0 = U_sur_D0 + analogRead(Ligne_trois_touches);
  U_sur_D0 = U_sur_D0 / NB_tests_antirebonds;
  if (U_sur_D0 < 813) {Num_BP = 1;
      if (U_sur_D0 < 478)  Num_BP = 2; if (U_sur_D0 < 223)  Num_BP = 3;}
  for (byte I = 0; I < NB_tests_antirebonds; I++) U_sur_D1 = U_sur_D1 + analogRead(Ligne_deux_touches);
  U_sur_D1 = U_sur_D1 / NB_tests_antirebonds; 
  if (U_sur_D1 < 776) {Num_BP = 4; if (U_sur_D1 < 302)  Num_BP = 5;}
  if (Num_BP != 0) ATTENDRE_le_relacher();}

  //--------------------------------------------------------------------------------------------------
void Delay_60() {delay(60);}

void Delay_200() {delay(200);}

void Alerte() {BIP(); Delay_200(); BIP(); Delay_200(); BIP();}

void Attendre_un_BP() {Num_BP = 0;
   while (Num_BP == 0) {digitalWrite(VERT, HIGH); Tester_le_Clavier(); Delay_60(); Eteindre_la_LED(); Delay_60();}}

void le_PGM_Interrogation() {Aff_TEXTE_EEPROM(218,4); Aff_TEXTE_EEPROM(133,3); SPC_Interrogation();}
  
void Debut_Nom(byte X, byte Y, byte N) {Afficher_un_texte(X, Y, 181, 3); u8g.print(N);} // "Pgm"
 
void AFF_Num_PGM(byte X, byte Y) {
  u8g.setPrintPos(X,Y); if (Num_PGM < 100) AFF_0(); if (Num_PGM < 10) AFF_0(); u8g.print(Num_PGM);}

//------------------------ Routines de gestion de l'affichage du BARILLET ------------------------
void Affiche_Origine(byte X, byte Y) {u8g.drawRFrame(X-2,Y-2,5,5,1); u8g.drawPixel(X,Y);}

void Affiche_PION(byte X, byte Etat) {
  if (Etat == 0) u8g.drawHLine(X-2,24,5);
  if (Etat == 1) u8g.drawRBox(X-2,18,5,7,0);
  if (Etat == 2) u8g.drawRBox(X-2,12,5,13,0);}

void Affiche_Repere_5(byte X) {u8g.drawVLine(X,26,7);}

void Affiche_1(byte X, byte Y) {
     u8g.drawVLine(X+1,Y-2,5); u8g.drawPixel(X,Y-1); u8g.drawPixel(X,Y+2); u8g.drawPixel(X+2,Y+2);}

void Affiche_0(byte X, byte Y) {
     u8g.drawVLine(X,Y-1,3); u8g.drawVLine(X+2,Y-1,3); u8g.drawPixel(X+1,Y+2); u8g.drawPixel(X+1,Y-2);}

void Affiche_Repere(byte X, byte Y, byte Valeur) {
  switch(Valeur) {
    case 1  : {Affiche_1(X,Y); break;}
    case 5  : {Affiche_Repere_5(X); break;}  
    case 10 : {Affiche_1(X-3,Y); Affiche_0(X+1,Y); break;}
    case 15 : {Affiche_Repere_5(X); break;}
    case 20 : {u8g.drawHLine(X-3,Y-2,2); u8g.drawHLine(X-3,Y+2,3); u8g.drawPixel(X-1,Y-1); u8g.drawPixel(X-2,Y);
               u8g.drawPixel(X-3,Y+1); Affiche_0(X+1,Y); break;}      
    case 25 : {Affiche_Repere_5(X); break;}
    case 30 : {u8g.drawHLine(X-3,Y-2,2); u8g.drawHLine(X-3,Y+2,2); u8g.drawPixel(X-1,Y-1);
               u8g.drawPixel(X-2,Y); u8g.drawPixel(X-1,Y+1); Affiche_0(X+1,Y); break;}
    case 35 : {Affiche_Repere_5(X); break;}
    case 40 : {u8g.drawVLine(X-1,Y-2,5); u8g.drawHLine(X-3,Y+1,4); u8g.drawPixel(X-3,Y);
               u8g.drawPixel(X-2,Y-1); Affiche_0(X+2, Y); break;}
    case 45 : {Affiche_Repere_5(X); break;}
    case 50 : {u8g.drawHLine(X-3,Y-2,3); u8g.drawHLine(X-3,Y,2); u8g.drawHLine(X-3,Y+2,2);
               u8g.drawPixel(X-3,Y-1); u8g.drawPixel(X-1,Y+1); Affiche_0(X+1,Y); break;}
    case 55 : Affiche_Repere_5(X);}}

void Affiche_le_BARILLET(){
  if (!Ecran_noir) {
     u8g.firstPage(); do {
     //---------------------- Affiche les lignes du plateau et la tête ----------------------
     u8g.drawHLine(0,25,128); u8g.drawHLine(0,33,128); u8g.drawRFrame(12,-3,9,13,3); u8g.drawHLine(12,0,9);
     //--------------------------- Affiche le petit E de la tête ----------------------------
     u8g.drawHLine(15,2,3); u8g.drawPixel(15,3); u8g.drawHLine(15,4,2); u8g.drawPixel(15,5); u8g.drawHLine(15,6,3);
     //-------------------------- Affiche les pions sous le plateau -------------------------
     for (byte X=2; X <127; X=X+12) u8g.drawRBox(X,34,5,3,0);
     //----------------------------- Affiche la référence du PGM ----------------------------
     Afficher_un_texte(44, 8, 181, 3); AFF_Num_PGM(63, 8);
     //------------------------------------- Affiche PAUSE ----------------------------------
     u8g.setPrintPos(95,8); u8g.print("PAUSE");
     //------------------------ Affiche le cadre des données du bas -------------------------
     u8g.setPrintPos(15,49); u8g.print("Tmp ");
     u8g.print(char(181)); u8g.print("P "); u8g.print("864000.03"); u8g.print(" S");
     u8g.setPrintPos(14,62); u8g.print(Nb_Cycles_Horloge); u8g.print(" Cycles.");
     //--------------------------------- Affiche les pions ----------------------------------
     for (byte X=4; X <127; X=X+12) Affiche_PION(X, Etat_des_BITs);
     //-------------------------------- Affiche les repères ---------------------------------
     Affiche_Repere(16,29,10); Affiche_Repere(40,29,5); Affiche_Repere(88,29,20); Affiche_Repere(112,29,50);
     Affiche_Origine(64,29);} while(u8g.nextPage());}}
 
//------------------------------ Affichage de la GRILLE du BARILLET ------------------------------

void Affiche_BIT_0(byte X, byte Y) {u8g.drawRFrame(X-2, Y-2,5,5,0);}

void Affiche_BIT_1(byte X, byte Y) {
  Affiche_BIT_0(X,Y); u8g.drawRFrame(X-3, Y-3,7,7,0); u8g.drawVLine(X-4,Y-3,7); u8g.drawVLine(X+4,Y-3,7);
  u8g.drawVLine(X-4,Y-3,7); u8g.drawVLine(X-5,Y-3,7); u8g.drawVLine(X+5,Y-3,7);}

void Affiche_la_GRILLE() {
  if (!Ecran_noir) {
     byte Index, X, Y ;
     //--------------------------------- Affiche la grille ----------------------------------
     u8g.firstPage(); do { u8g.drawRFrame(13,2,101,61,0);
     for (byte I= 4; I<63; I = I+8) u8g.drawHLine(16,I,95);
     for (byte I= 15; I<120; I = I+12) u8g.drawVLine(I,4,57);
     //--------------------------------- Affiche l'origine ----------------------------------
     Index = 0; X = 0; Y = 1;
     while (Index != Origine) {Index++; X++; if (X == 9) {X = 1; Y++;}}
     X = (X * 12) + 3; Y = (Y * 8) - 4;
     u8g.drawHLine(X,1,13); u8g.drawVLine(12,Y,9); u8g.drawVLine(11,Y,9);
     //------------------------ Affiche les PIXELs des repères en 5 -------------------------
     u8g.drawPixel(69,8); u8g.drawPixel(93,16); u8g.drawPixel(21,32);
     u8g.drawPixel(45,40); u8g.drawPixel(69,48); u8g.drawPixel(93,56);
     //--------------------------- Affiche les repèrères décimaux ---------------------------
     Affiche_Repere(21, 8, 1); Affiche_Repere(33, 16, 10); Affiche_Repere(57, 24, 20);
     Affiche_Repere(81, 32, 30); Affiche_Repere(105, 40, 40); Affiche_Repere(33, 56, 50);} while(u8g.nextPage());}}
  
  

